-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local hasSentMapData = false
local vehicleID = obj:getID()
local naviScreenName = "@b2_c2_screen_lua"
--local gaugesScreenName = "@etk800_gauges_screen"
local gaugesScreenName = "@c2_lcd"

local timer = 0
local doorsthreshold = 0.1
local doors = {}

local engDIEDED = false
local radDIEDED = false

local function runFunc(func)
	obj:queueGameEngineLua("if be:getObjectByID("..vehicleID..") then be:getObjectByID("..vehicleID.."):queueJSUITexture('"..gaugesScreenName.."', '"..func.."') end")
end

local function initDoors()
	doors["FL"]= {}
	doors["FL"]["bk"]= {"C2_doorlatch_L"}--,"C2_doorhinge_a_L","C2_doorhinge_b_L"}
	doors["FL"]["beams"]={}
	doors["FL"]["broken"]=false
	--doors["RL"]= {}
	--doors["RL"]["bk"]= ""
	--doors["RL"]["beams"]={}
	--doors["RL"]["broken"]=false
	doors["R"]= {}
	doors["R"]["bk"]= {"C2_tailgatelatch_up","C2_tailgatehinge_L","C2_tailgatehinge_R","C2_tailgatelatch"}
	doors["R"]["beams"]={}
	doors["R"]["broken"]=false
	--doors["RR"]= {}
	--doors["RR"]["bk"]= ""
	--doors["RR"]["beams"]={}
	--doors["RR"]["broken"]=false
	doors["FR"]= {}
	doors["FR"]["bk"]= {"C2_doorlatch_R"}--,"C2_doorhinge_a_R","C2_doorhinge_b_R"}
	doors["FR"]["beams"]={}
	doors["FR"]["broken"]=false

	for _,b in pairs(v.data.beams) do
		if b.breakGroup and b.breakGroup ~= "" then--and b.breakGroup == "C2_doorlatch_R" then
			
			for k,br in pairs(doors) do
				for _,bki in pairs(br["bk"]) do
					if b.breakGroup == bki then
						ob = {}
						ob["id"]=b.cid
						ob["l"]=obj:getBeamLength(b.cid)
						table.insert(br["beams"], ob )
					end
				end
			end
			
			
			--beamdoor = b.cid
			--lendoor = obj:getBeamLength(beamdoor)
			--log('D', "C2.init",  "Beam door found "..beamdoor)
			--log('D', "C2.init",  "Beam door len= ".. lendoor .."lenREF= " ..obj:getBeamLengthRefRatio(beamdoor) .. "lenREST= "..obj:getBeamLengthRestRatio(beamdoor)  )
		end
    end
	log('D', "C2.init",  "Beam door FL ".. table.getn( doors["FL"]["beams"]) )
	--log('D', "C2.init",  "Beam door RL ".. table.getn( doors["RL"]["beams"]) )
	log('D', "C2.init",  "Beam door R ".. table.getn( doors["R"]["beams"]) )
	log('D', "C2.init",  "Beam door FR ".. table.getn( doors["FR"]["beams"]) )
	--log('D', "C2.init",  "Beam door RR ".. table.getn( doors["RR"]["beams"]) )
end

local function updateDoors()
	for k,d in pairs(doors) do
		if d["broken"] == false then
			for _,bd in pairs(d["beams"]) do
				local lenp = obj:getBeamLength(bd["id"])
				if lenp > (bd["l"]*doorsthreshold+bd["l"]) or lenp < (bd["l"]-bd["l"]*doorsthreshold) then
					d["broken"] = true
					log('D', "C2.updateDoors",  "door broken".. k )
					runFunc( "updateDoors(".. tostring(doors["FL"]["broken"]) ..",0,".. tostring(doors["R"]["broken"]) ..",0,".. tostring(doors["FR"]["broken"]) ..")" )
					break
				end
			end
		end
	end
end


local function onInit()
    hasSentMapData = false
    obj:queueGameEngineLua("extensions.loadModule('ui/uinavi')")
    obj:queueGameEngineLua('be:getObjectByID('..vehicleID..'):createUITexture("'..naviScreenName..'", "local://local/'..v.vehicleDirectory..'navi_screen.html", 256, 128, UI_TEXTURE_USAGE_AUTOMATIC, 30)')
	obj:queueGameEngineLua("uinavi.requestVehicleDashboardMap('"..naviScreenName.."')")
    obj:queueGameEngineLua('be:getObjectByID('..vehicleID..'):createUITexture("'..gaugesScreenName..'", "local://local/vehicles/common/C2/gauges_screen.html", 1024, 1024, UI_TEXTURE_USAGE_AUTOMATIC, 30)')
    
    hasSentMapData = true
	
	initDoors()
	runFunc("updateCC( false, 0)")
	
end

local function onReset()
    --local destroy = 'be:getObjectByID('..vehicleID..'):destroyUITexture("'..naviScreenName..'")'
    --obj:queueGameEngineLua(destroy)
    onInit()
end

local function updateGFX(dt)
    if hasSentMapData then
        local pos = obj:getPosition()
        local rotation = math.deg(obj:getDirection()) + 180
        local speedgps = (electrics.values.airspeed or 0) * 3.6
		local speed = (electrics.values.wheelspeed or 0) * 3.6
        local zoom = math.min(150 + speedgps * 1.5, 250)

        obj:queueGameEngineLua("if be:getObjectByID("..vehicleID..") then be:getObjectByID("..vehicleID.."):queueJSUITexture('"..naviScreenName.."', 'map.setPosition("..pos.x..", "..pos.y..", "..rotation..")') end")
        obj:queueGameEngineLua("if be:getObjectByID("..vehicleID..") then be:getObjectByID("..vehicleID.."):queueJSUITexture('"..naviScreenName.."', 'map.setZoom("..zoom..")') end")
		
		timer = timer + dt
		runFunc("updateSpd("..speed..",".. dt ..")")
		
		if timer > 0.5 then
			--obj:queueGameEngineLua("be:getObjectByID("..vehicleID.."):queueJSUITexture('"..gaugesScreenName.."', 'updateData("..math.ceil(speed)..", "..drivetrain.gear..")')")
			--obj:queueGameEngineLua("if be:getObjectByID("..vehicleID..") then be:getObjectByID("..vehicleID.."):queueJSUITexture('"..gaugesScreenName.."', 'updateData("..speed..", "..drivetrain.gear..")') end")
			
			--runFunc("updateGear("..drivetrain.gear..",".. v.data.engine.transmissionType ..")")
			runFunc("updateGear(".. (drivetrain.gear or 0) .. "," .. (drivetrain.shifterMode or 0) ..")")
			runFunc("updateFuel(".. (electrics.values.fuel or 0) ..")")
			--lights
			timer=0
			

			updateDoors()
			local unit = tostring( settings.getValue("uiUnitLength") )
			--print("Unit='" .. unit .. "' metric".. tostring(unit=="metric"))
			runFunc("updateUnit(".. tostring( ( unit or 'metric') == "metric") ..")")
			
			local tEnv = obj:getEnvTemperature() -273.15
			runFunc("updateTemp(".. tostring(tEnv) ..")")
			
			runFunc('updateLang( "'.. settings.getValue("userLanguage") ..'" )')
			
			--cruiseControl.requestState()
			--runFunc("updateCC(".. cruiseControl.isEnabled ..", ".. cruiseControl.targetSpeed ..")")
			
			local dev = powertrain.getDevices()
			if engDIEDED ~= dev['mainEngine']['thermals']['engineBlockMelted'] or radDIEDED ~= (dev['mainEngine']['thermals']['radiatorDamage'] > 0) then
				engDIEDED = dev['mainEngine']['thermals']['engineBlockMelted'] 
				radDIEDED = dev['mainEngine']['thermals']['radiatorDamage'] > 0
				runFunc("updateDamage(" .. tostring(engDIEDED) ..", ".. tostring(radDIEDED) ..")")
			end 
			
			--add electrics values for glowmap
			electrics.values.temp = (electrics.values.watertemp or 0) >= 120 or radDIEDED
		end
		
    end
end

local function beamBroken(id, energy)
      local m ="beam "..id.." just broke: " .. v.data.nodes[beam.id1].name .. " ["..beam.id1.."]" .."  ->  " .. v.data.nodes[beam.id2].name .. " ["..beam.id2.."]"
	log('D', "C2.beamBroken", m)
end

-- public interface
M.onInit    = onInit
M.onReset   = onReset
M.updateGFX = updateGFX
M.beamBroken= beamBroken

return M
